# Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
# 
.PHONY: all clean

ifeq "$(CCENV)" "GCC_UNIX"
all: $(OBJS)
	$(AR) $(S_TARGET) $(OBJS)
	$(LD) -r -o $(notdir $(shell pwd).$(OBJEXT)) $(OBJS)
clean:
	-$(RM) $(filter-out Makefile %.c %.h,$(notdir $(shell find . -maxdepth 1 -name "*" -type f)))
endif

ifeq "$(CCENV)" "GCC_WINNT"
all: $(OBJS)
	$(AR) $(S_TARGET) $(OBJS)
	$(LD) -r -o $(notdir $(shell cd).$(OBJEXT)) $(OBJS)
clean:
	-$(RM) $(filter-out Makefile %.c %.h,$(shell dir /a-d /b)) 2>nul
endif

ifeq "$(CCENV)" "MSC_WINNT"
all: $(OBJS)
clean:
	-$(RM) $(filter-out Makefile %.c %.h,$(shell dir /a-d /b)) 2>nul
endif

ifeq "$(CCENV)" "BCC_DOS"
all: $(OBJS)
	@for /l %%i in (0,1,128) do cd 1> nul
	for %%i in ($(OBJS)) do if exist %%i ($(AR) $(S_TARGET) +%%i) else echo "Comile for %%i failed!" &&exit 1
clean:
	-$(RM) $(filter-out Makefile %.c %.h,$(shell dir /a-d /b)) 2>nul
endif

%.$(OBJEXT): %.c
	$(CC) $(CFLAGS) -c $<
