/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_RMPCHR_DEBUG)
#include <stdio.h>
#endif
#include <string.h>

/* Remove paratactic char(s) from src, leaving only one instance.
 * return a pointer to changed src. */
char *rmpchr(char *src, int c)
{
	char *p = src, *t, *q;

#ifdef STR_DEBUG
	printf("rmpchr(): src=\"%s\"\n", src);
#endif
	while(*p) {
		t = strchr(p, c);
		if(t) { /* char found. */
			for(q=++t; *q && *q == c;) /* find next non-char. */
				++q;
#ifdef STR_DEBUG
			printf("rmpchr(): q=\"%s\"\nt=\"%s\"\n", q, t);
#endif
			if(q != t) /* copy & overwrite paratactic char(s). */
				strcpy(t, q);
			p = t; /* loop indicator. */
		} else /* done. */
			break;
	}
#ifdef STR_DEBUG
	printf("rmpchr(): changed src=\"%s\"\n\n", src);
#endif
	return src;
}

#ifdef STR_RMPCHR_DEBUG
int main(void)
{
	char buf[512]=" hi, this  is   hcq0411    ";
	rmpchr(buf,' ');

	strcpy(buf, "");
	rmpchr(buf,' ');

	strcpy(buf, "hi,thiisiiiiiiiiiiihcq0411");
	rmpchr(buf,'i');

	strcpy(buf, "              hi, th       isish           cq04     11");
	rmpchr(buf,'\0');
	return 0;
}
#endif
